import { ListPanelItemModel as ListPanelItemModel_internal } from "./ListPanelItemModel";
import { ensureBool } from "igniteui-webcomponents-core";
export class IgcListPanelItemModel {
    createImplementation() {
        return new ListPanelItemModel_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get dataRow() {
        return this.i.n;
    }
    set dataRow(v) {
        this.i.n = +v;
    }
    get rowHeight() {
        return this.i.l;
    }
    set rowHeight(v) {
        this.i.l = +v;
    }
    get rowObject() {
        return this.i.p;
    }
    set rowObject(v) {
        this.i.p = v;
    }
    get isModelDirty() {
        return this.i.g;
    }
    set isModelDirty(v) {
        this.i.g = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
