import { IgcLayoutSelectedKeysCollection } from "./igc-layout-selected-keys-collection";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionCheckboxList } from "./ToolActionCheckboxList";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { LayoutSelectedKeysCollection as LayoutSelectedKeysCollection_internal } from "./LayoutSelectedKeysCollection";
import { LayoutPrimaryKeyValue } from "./LayoutPrimaryKeyValue";
import { SyncableObservableCollection$1 } from "igniteui-webcomponents-core";
export let IgcToolActionCheckboxListComponent = /*@__PURE__*/ (() => {
    class IgcToolActionCheckboxListComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionCheckboxList();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
            this._selectedKeys = null;
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent == null) {
                let names = getAllPropertyNames(IgcToolActionCheckboxListComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent = names;
            }
            return IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent;
        }
        static register() {
            if (!IgcToolActionCheckboxListComponent._isElementRegistered) {
                IgcToolActionCheckboxListComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionCheckboxListComponent.htmlTagName, IgcToolActionCheckboxListComponent);
            }
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get dataSource() {
            return this.i.itemsSource;
        }
        set dataSource(v) {
            this.i.itemsSource = v;
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get selectedMemberPath() {
            return this.i.hr;
        }
        set selectedMemberPath(v) {
            this.i.hr = v;
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get dataMemberPath() {
            return this.i.hm;
        }
        set dataMemberPath(v) {
            this.i.hm = v;
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get primaryKey() {
            return this.i.hb;
        }
        set primaryKey(v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                const re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.hb = v;
        }
        /**
        
        */
        get selectedKeys() {
            if (this._selectedKeys === null) {
                let coll = new IgcLayoutSelectedKeysCollection();
                let innerColl = this.i.hc;
                if (!innerColl) {
                    innerColl = new LayoutSelectedKeysCollection_internal();
                }
                this._selectedKeys = coll._fromInner(innerColl);
                this.i.hc = innerColl;
            }
            return this._selectedKeys;
        }
        set selectedKeys(v) {
            if (this._selectedKeys !== null) {
                this._selectedKeys._setSyncTarget(null);
                this._selectedKeys = null;
            }
            let coll = new IgcLayoutSelectedKeysCollection();
            this._selectedKeys = coll._fromOuter(v);
            let syncColl = new SyncableObservableCollection$1(LayoutPrimaryKeyValue.$type);
            let innerColl = this.i.hc;
            if (!innerColl) {
                innerColl = new LayoutSelectedKeysCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedKeys._setSyncTarget(syncColl);
            this.i.hc = innerColl;
        }
        findByName(name) {
            var baseResult = super.findByName(name);
            if (baseResult) {
                return baseResult;
            }
            if (this.selectedKeys != null && this.selectedKeys.findByName && this.selectedKeys.findByName(name)) {
                return this.selectedKeys.findByName(name);
            }
            return null;
        }
    }
    IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent = null;
    IgcToolActionCheckboxListComponent.htmlTagName = "igc-tool-action-checkbox-list";
    IgcToolActionCheckboxListComponent._isElementRegistered = false;
    return IgcToolActionCheckboxListComponent;
})();
