import { __extends } from "tslib";
import { IgcLayoutSelectedKeysCollection } from "./igc-layout-selected-keys-collection";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionCheckboxList } from "./ToolActionCheckboxList";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { LayoutSelectedKeysCollection as LayoutSelectedKeysCollection_internal } from "./LayoutSelectedKeysCollection";
import { LayoutPrimaryKeyValue } from "./LayoutPrimaryKeyValue";
import { SyncableObservableCollection$1 } from "igniteui-webcomponents-core";
var IgcToolActionCheckboxListComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionCheckboxListComponent, _super);
    function IgcToolActionCheckboxListComponent() {
        var _this = _super.call(this) || this;
        _this._selectedKeys = null;
        return _this;
    }
    IgcToolActionCheckboxListComponent.prototype.createImplementation = function () {
        return new ToolActionCheckboxList();
    };
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxListComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionCheckboxListComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionCheckboxListComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent == null) {
                var names = getAllPropertyNames(IgcToolActionCheckboxListComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent = names;
            }
            return IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxListComponent.register = function () {
        if (!IgcToolActionCheckboxListComponent._isElementRegistered) {
            IgcToolActionCheckboxListComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionCheckboxListComponent.htmlTagName, IgcToolActionCheckboxListComponent);
        }
    };
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "dataSource", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.itemsSource;
        },
        set: function (v) {
            this.i.itemsSource = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "selectedMemberPath", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.hr;
        },
        set: function (v) {
            this.i.hr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "dataMemberPath", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.hm;
        },
        set: function (v) {
            this.i.hm = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "primaryKey", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.hb;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.hb = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionCheckboxListComponent.prototype, "selectedKeys", {
        /**
        
        */
        get: function () {
            if (this._selectedKeys === null) {
                var coll = new IgcLayoutSelectedKeysCollection();
                var innerColl = this.i.hc;
                if (!innerColl) {
                    innerColl = new LayoutSelectedKeysCollection_internal();
                }
                this._selectedKeys = coll._fromInner(innerColl);
                this.i.hc = innerColl;
            }
            return this._selectedKeys;
        },
        set: function (v) {
            if (this._selectedKeys !== null) {
                this._selectedKeys._setSyncTarget(null);
                this._selectedKeys = null;
            }
            var coll = new IgcLayoutSelectedKeysCollection();
            this._selectedKeys = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(LayoutPrimaryKeyValue.$type);
            var innerColl = this.i.hc;
            if (!innerColl) {
                innerColl = new LayoutSelectedKeysCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedKeys._setSyncTarget(syncColl);
            this.i.hc = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxListComponent.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.selectedKeys != null && this.selectedKeys.findByName && this.selectedKeys.findByName(name)) {
            return this.selectedKeys.findByName(name);
        }
        return null;
    };
    IgcToolActionCheckboxListComponent._observedAttributesIgcToolActionCheckboxListComponent = null;
    IgcToolActionCheckboxListComponent.htmlTagName = "igc-tool-action-checkbox-list";
    IgcToolActionCheckboxListComponent._isElementRegistered = false;
    return IgcToolActionCheckboxListComponent;
}(IgcToolActionComponent));
export { IgcToolActionCheckboxListComponent };
