import { __extends, __values } from "tslib";
import { fromSize, ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, toSpinal, enumToString, getAllPropertyNames, fromSpinal } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { WebComponentRenderer, PortalManager } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { CollectionAdapter } from "igniteui-webcomponents-core";
import { NotifyCollectionChangedAction } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { ToolPanel } from "./ToolPanel";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { ToolPanelOrientation_$type } from './ToolPanelOrientation';
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { IgcToolActionCollection } from "./igc-tool-action-collection";
import { IgcToolPanelContentRefreshedEventArgs } from "./igc-tool-panel-content-refreshed-event-args";
import { IgcToolCommandEventArgs } from './igc-tool-command-event-args';
import { NestedActionMode_$type } from './NestedActionMode';
var IgcToolPanelComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolPanelComponent, _super);
    function IgcToolPanelComponent() {
        var _this = _super.call(this) || this;
        _this._implementation = null;
        _this.contentActions = [];
        /**
        * The actions actually present in the editor. Do not directly modify this array.
        * This array's contents can be modified by using the actions property or providing child content.
        */
        _this.actualActions = [];
        _this._actions = null;
        _this._actionsAdapter = null;
        _this._disconnected = false;
        _this._settingAttributes = false;
        _this._attached = false;
        _this._queuedSetAttributes = [];
        _this._updatingFromAttribute = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._contentRefreshed = null;
        _this._contentRefreshed_wrapped = null;
        _this._onCommand = null;
        _this._onCommand_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this._portalManager = new PortalManager("toolPanelContent");
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, {}, _this._portalManager);
        _this._webComponentWrapper = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._webComponentWrapper);
        _this._webComponentWrapper.setStyleProperty("display", "block");
        _this._webComponentWrapper.setStyleProperty("width", "100%");
        _this._webComponentWrapper.setStyleProperty("height", "100%");
        _this._actionsAdapter = new CollectionAdapter(_this.contentActions, _this.i.actions, _this.actualActions, function (c) { return c.i; }, function (i) {
            if (_this._webComponentRenderer && _this._webComponentRenderer.rootWrapper.getNativeElement().parentElement) {
                i._styling(_this, _this, _this);
            }
        }, function (i) { });
        _this.i.provideContainer(_this._webComponentRenderer);
        _this.i.notifySizeChanged();
        var mut = new MutationObserver(function (list) {
            var e_1, _b;
            try {
                for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                    var mutation = list_1_1.value;
                    if (mutation.type == 'childList') {
                        _this.updateContentProperties();
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (list_1_1 && !list_1_1.done && (_b = list_1.return))
                        _b.call(list_1);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        });
        mut.observe(_this, {
            childList: true
        });
        _this._webComponentRenderer.addSizeWatcher(function () {
            _this.i.notifySizeChanged();
        });
        return _this;
    }
    Object.defineProperty(IgcToolPanelComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
            this.i.notifySizeChanged();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
            this.i.notifySizeChanged();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actions", {
        /**
         * A collection of manually added actions for the editor.
        */
        get: function () {
            var _this = this;
            if (this._actions === null) {
                var coll = new IgcToolActionCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._actionsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._actionsAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._actionsAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._actionsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._actionsAdapter.clearManualItems();
                            break;
                    }
                });
                this._actions = coll;
            }
            return this._actions;
        },
        enumerable: false,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    IgcToolPanelComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcToolPanelComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcToolPanelComponent.prototype.updateContentProperties = function () {
        this.contentActions.length = 0;
        for (var i = 0; i < this.children.length; i++) {
            if (this.children[i] instanceof IgcToolActionComponent) {
                this.contentActions.push(this.children[i]);
            }
        }
        if (this._actionsAdapter != null) {
            this._actionsAdapter.notifyContentChanged();
        }
    };
    IgcToolPanelComponent.prototype.createImplementation = function () {
        return new ToolPanel();
    };
    Object.defineProperty(IgcToolPanelComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolPanelComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcToolPanelComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-tool-panel");
        this.classList.add("igc-tool-panel");
        var rootWrapper = this._webComponentRenderer.rootWrapper;
        var rootElement = rootWrapper.getNativeElement();
        this.appendChild(rootElement);
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        for (var i = 0; i < this.actualActions.length; i++) {
            var s = this.actualActions[i];
            s._styling(this, this, this);
        }
        this.afterContentInit();
    };
    IgcToolPanelComponent.prototype.afterContentInit = function () {
        this.i.notifySizeChanged();
    };
    IgcToolPanelComponent.prototype._enqueueSetAttribute = function (attrName, attrValue) {
        this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
    };
    IgcToolPanelComponent.prototype._flushQueuedAttributes = function () {
        this._settingAttributes = true;
        for (var i = 0; i < this._queuedSetAttributes.length; i++) {
            this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
        }
        this._settingAttributes = false;
        this._queuedSetAttributes.length = 0;
    };
    IgcToolPanelComponent.prototype._a = function (attrName, attrValue) {
        if (this._updatingFromAttribute) {
            return;
        }
        if (attrValue) {
            attrValue = attrValue.toString();
        }
        this._settingAttributes = true;
        attrName = toSpinal(attrName);
        if (this._attached) {
            this.setAttribute(attrName, attrValue);
        }
        else {
            this._enqueueSetAttribute(attrName, attrValue);
        }
        this._settingAttributes = false;
    };
    Object.defineProperty(IgcToolPanelComponent, "observedAttributes", {
        get: function () {
            if (IgcToolPanelComponent._observedAttributesIgcToolPanelComponent == null) {
                var names = getAllPropertyNames(IgcToolPanelComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolPanelComponent._observedAttributesIgcToolPanelComponent = names;
            }
            return IgcToolPanelComponent._observedAttributesIgcToolPanelComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolPanelComponent.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (this._settingAttributes) {
            return;
        }
        var setName = fromSpinal(name);
        this._updatingFromAttribute = true;
        this[setName] = newValue;
        this._updatingFromAttribute = false;
    };
    IgcToolPanelComponent.register = function () {
        if (!IgcToolPanelComponent._isElementRegistered) {
            IgcToolPanelComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolPanelComponent.htmlTagName, IgcToolPanelComponent);
        }
    };
    Object.defineProperty(IgcToolPanelComponent.prototype, "showOnHover", {
        /**
     * Gets or sets if the tool actions should display their submenus on mouse hover.
    */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = ensureBool(v);
            this._a("showOnHover", this.i.al);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "cellTextStyle", {
        /**
         * Gets or sets the text style for the panel.
        */
        get: function () {
            if (this.i.ab == null) {
                return null;
            }
            return this.i.ab.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ab = fi;
            this._a("cellTextStyle", this.i.ab != null ? this.i.ab.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "subtitleTextStyle", {
        /**
         * Gets or sets the subtitle text style for the panel.
        */
        get: function () {
            if (this.i.ad == null) {
                return null;
            }
            return this.i.ad.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ad = fi;
            this._a("subtitleTextStyle", this.i.ad != null ? this.i.ad.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "baseTheme", {
        /**
         * Gets or sets the base built in theme to use for the checkbox.
        */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = ensureEnum(BaseControlTheme_$type, v);
            this._a("baseTheme", enumToString(BaseControlTheme_$type, this.i.u));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return brushToString(this.i.ha);
        },
        set: function (v) {
            this.i.ha = stringToBrush(v);
            this._a("backgroundColor", brushToString(this.i.ha));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualBackgroundColor", {
        get: function () {
            return brushToString(this.i.gp);
        },
        set: function (v) {
            this.i.gp = stringToBrush(v);
            this._a("actualBackgroundColor", brushToString(this.i.gp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "submenuBackgroundColor", {
        /**
         * Gets or sets the background color for submenus.
        */
        get: function () {
            return brushToString(this.i.ho);
        },
        set: function (v) {
            this.i.ho = stringToBrush(v);
            this._a("submenuBackgroundColor", brushToString(this.i.ho));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSubmenuBackgroundColor", {
        get: function () {
            return brushToString(this.i.g3);
        },
        set: function (v) {
            this.i.g3 = stringToBrush(v);
            this._a("actualSubmenuBackgroundColor", brushToString(this.i.g3));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "groupHeaderBackgroundColor", {
        /**
         * Gets or sets the group header background color.
        */
        get: function () {
            return brushToString(this.i.he);
        },
        set: function (v) {
            this.i.he = stringToBrush(v);
            this._a("groupHeaderBackgroundColor", brushToString(this.i.he));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualGroupHeaderBackgroundColor", {
        get: function () {
            return brushToString(this.i.gt);
        },
        set: function (v) {
            this.i.gt = stringToBrush(v);
            this._a("actualGroupHeaderBackgroundColor", brushToString(this.i.gt));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorBackgroundColor", {
        /**
         * Gets or sets the separator background color.
        */
        get: function () {
            return brushToString(this.i.hn);
        },
        set: function (v) {
            this.i.hn = stringToBrush(v);
            this._a("separatorBackgroundColor", brushToString(this.i.hn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorBackgroundColor", {
        get: function () {
            return brushToString(this.i.g2);
        },
        set: function (v) {
            this.i.g2 = stringToBrush(v);
            this._a("actualSeparatorBackgroundColor", brushToString(this.i.g2));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "groupHeaderSeparatorBackgroundColor", {
        /**
         * Gets or sets the group header separator background color.
        */
        get: function () {
            return brushToString(this.i.hf);
        },
        set: function (v) {
            this.i.hf = stringToBrush(v);
            this._a("groupHeaderSeparatorBackgroundColor", brushToString(this.i.hf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualGroupHeaderSeparatorBackgroundColor", {
        get: function () {
            return brushToString(this.i.gu);
        },
        set: function (v) {
            this.i.gu = stringToBrush(v);
            this._a("actualGroupHeaderSeparatorBackgroundColor", brushToString(this.i.gu));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "hoverBackgroundColor", {
        /**
         * Gets or sets the hover background color.
        */
        get: function () {
            return brushToString(this.i.hj);
        },
        set: function (v) {
            this.i.hj = stringToBrush(v);
            this._a("hoverBackgroundColor", brushToString(this.i.hj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualHoverBackgroundColor", {
        get: function () {
            return brushToString(this.i.gy);
        },
        set: function (v) {
            this.i.gy = stringToBrush(v);
            this._a("actualHoverBackgroundColor", brushToString(this.i.gy));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the component.
        */
        get: function () {
            return brushToString(this.i.hq);
        },
        set: function (v) {
            this.i.hq = stringToBrush(v);
            this._a("textColor", brushToString(this.i.hq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualTextColor", {
        get: function () {
            return brushToString(this.i.g5);
        },
        set: function (v) {
            this.i.g5 = stringToBrush(v);
            this._a("actualTextColor", brushToString(this.i.g5));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSubtitleTextColor", {
        get: function () {
            return brushToString(this.i.g4);
        },
        set: function (v) {
            this.i.g4 = stringToBrush(v);
            this._a("actualSubtitleTextColor", brushToString(this.i.g4));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "subtitleTextColor", {
        /**
         * Gets or sets the color to use for the subtitle of the component.
        */
        get: function () {
            return brushToString(this.i.hp);
        },
        set: function (v) {
            this.i.hp = stringToBrush(v);
            this._a("subtitleTextColor", brushToString(this.i.hp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "disabledTextColor", {
        /**
         * Gets or sets the color to use for the text in disabled tool actions.
        */
        get: function () {
            return brushToString(this.i.hd);
        },
        set: function (v) {
            this.i.hd = stringToBrush(v);
            this._a("disabledTextColor", brushToString(this.i.hd));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualDisabledTextColor", {
        get: function () {
            return brushToString(this.i.gs);
        },
        set: function (v) {
            this.i.gs = stringToBrush(v);
            this._a("actualDisabledTextColor", brushToString(this.i.gs));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "groupHeaderTextColor", {
        /**
         * Gets or sets the text color for group header tool actions.
        */
        get: function () {
            return brushToString(this.i.hh);
        },
        set: function (v) {
            this.i.hh = stringToBrush(v);
            this._a("groupHeaderTextColor", brushToString(this.i.hh));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualGroupHeaderTextColor", {
        get: function () {
            return brushToString(this.i.gw);
        },
        set: function (v) {
            this.i.gw = stringToBrush(v);
            this._a("actualGroupHeaderTextColor", brushToString(this.i.gw));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "groupHeaderSubtitleTextColor", {
        /**
         * Gets or sets the text color for group header subtitle.
        */
        get: function () {
            return brushToString(this.i.hg);
        },
        set: function (v) {
            this.i.hg = stringToBrush(v);
            this._a("groupHeaderSubtitleTextColor", brushToString(this.i.hg));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualGroupHeaderSubtitleTextColor", {
        get: function () {
            return brushToString(this.i.gv);
        },
        set: function (v) {
            this.i.gv = stringToBrush(v);
            this._a("actualGroupHeaderSubtitleTextColor", brushToString(this.i.gv));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "toolTipTextColor", {
        /**
         * Gets or sets the tooltip text color.
        */
        get: function () {
            return brushToString(this.i.hs);
        },
        set: function (v) {
            this.i.hs = stringToBrush(v);
            this._a("toolTipTextColor", brushToString(this.i.hs));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualToolTipTextColor", {
        get: function () {
            return brushToString(this.i.g7);
        },
        set: function (v) {
            this.i.g7 = stringToBrush(v);
            this._a("actualToolTipTextColor", brushToString(this.i.g7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "toolTipBackgroundColor", {
        /**
         * Gets or sets the tooltip background color.
        */
        get: function () {
            return brushToString(this.i.hr);
        },
        set: function (v) {
            this.i.hr = stringToBrush(v);
            this._a("toolTipBackgroundColor", brushToString(this.i.hr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualToolTipBackgroundColor", {
        /**
         * Gets the actual tooltip background color.
        */
        get: function () {
            return brushToString(this.i.g6);
        },
        set: function (v) {
            this.i.g6 = stringToBrush(v);
            this._a("actualToolTipBackgroundColor", brushToString(this.i.g6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "toolTipCornerRadius", {
        /**
         * Gets or sets the tooltip corner radius.
        */
        get: function () {
            return this.i.b2;
        },
        set: function (v) {
            this.i.b2 = +v;
            this._a("toolTipCornerRadius", this.i.b2);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualToolTipCornerRadius", {
        /**
         * Gets the actual tooltip corner radius.
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = +v;
            this._a("actualToolTipCornerRadius", this.i.bq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "toolTipElevation", {
        /**
         * Gets or sets the shadow elevation for the tooltip.
        */
        get: function () {
            return this.i.b3;
        },
        set: function (v) {
            this.i.b3 = +v;
            this._a("toolTipElevation", this.i.b3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualToolTipElevation", {
        /**
         * Gets the actual shadow elevation used by the tooltip.
        */
        get: function () {
            return this.i.br;
        },
        set: function (v) {
            this.i.br = +v;
            this._a("actualToolTipElevation", this.i.br);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "iconFill", {
        /**
         * Gets or sets the fill color of icons in the ToolPanel.
        */
        get: function () {
            return brushToString(this.i.hk);
        },
        set: function (v) {
            this.i.hk = stringToBrush(v);
            this._a("iconFill", brushToString(this.i.hk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualIconFill", {
        /**
         * Gets the actual icon fill color.
        */
        get: function () {
            return brushToString(this.i.gz);
        },
        set: function (v) {
            this.i.gz = stringToBrush(v);
            this._a("actualIconFill", brushToString(this.i.gz));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "iconStroke", {
        /**
         * Gets or sets the stroke color of icons in the ToolPanel.
        */
        get: function () {
            return brushToString(this.i.hl);
        },
        set: function (v) {
            this.i.hl = stringToBrush(v);
            this._a("iconStroke", brushToString(this.i.hl));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualIconStroke", {
        /**
         * Gets the actual icon stroke color.
        */
        get: function () {
            return brushToString(this.i.g0);
        },
        set: function (v) {
            this.i.g0 = stringToBrush(v);
            this._a("actualIconStroke", brushToString(this.i.g0));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorVerticalPaddingLeft", {
        /**
         * Gets or sets the left padding for separators in the vertical orientation.
        */
        get: function () {
            return this.i.bz;
        },
        set: function (v) {
            this.i.bz = +v;
            this._a("separatorVerticalPaddingLeft", this.i.bz);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorVerticalPaddingLeft", {
        get: function () {
            return this.i.bn;
        },
        set: function (v) {
            this.i.bn = +v;
            this._a("actualSeparatorVerticalPaddingLeft", this.i.bn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorVerticalPaddingRight", {
        /**
         * Gets or sets the right padding for separators in the vertical orientation.
        */
        get: function () {
            return this.i.b0;
        },
        set: function (v) {
            this.i.b0 = +v;
            this._a("separatorVerticalPaddingRight", this.i.b0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorVerticalPaddingRight", {
        get: function () {
            return this.i.bo;
        },
        set: function (v) {
            this.i.bo = +v;
            this._a("actualSeparatorVerticalPaddingRight", this.i.bo);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorVerticalPaddingTop", {
        /**
         * Gets or sets the top padding for separators in the vertical orientation.
        */
        get: function () {
            return this.i.b1;
        },
        set: function (v) {
            this.i.b1 = +v;
            this._a("separatorVerticalPaddingTop", this.i.b1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorVerticalPaddingTop", {
        get: function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = +v;
            this._a("actualSeparatorVerticalPaddingTop", this.i.bp);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorVerticalPaddingBottom", {
        /**
         * Gets or sets the bottom padding for separators in the vertical orientation.
        */
        get: function () {
            return this.i.by;
        },
        set: function (v) {
            this.i.by = +v;
            this._a("separatorVerticalPaddingBottom", this.i.by);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorVerticalPaddingBottom", {
        get: function () {
            return this.i.bm;
        },
        set: function (v) {
            this.i.bm = +v;
            this._a("actualSeparatorVerticalPaddingBottom", this.i.bm);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorHorizontalPaddingLeft", {
        /**
         * Gets or sets the left padding for separators in the horizontal orientation.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = +v;
            this._a("separatorHorizontalPaddingLeft", this.i.bv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorHorizontalPaddingLeft", {
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = +v;
            this._a("actualSeparatorHorizontalPaddingLeft", this.i.bj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorHorizontalPaddingRight", {
        /**
         * Gets or sets the right padding for separators in the horizontal orientation.
        */
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = +v;
            this._a("separatorHorizontalPaddingRight", this.i.bw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorHorizontalPaddingRight", {
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = +v;
            this._a("actualSeparatorHorizontalPaddingRight", this.i.bk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorHorizontalPaddingTop", {
        /**
         * Gets or sets the top padding for separators in the horizontal orientation.
        */
        get: function () {
            return this.i.bx;
        },
        set: function (v) {
            this.i.bx = +v;
            this._a("separatorHorizontalPaddingTop", this.i.bx);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorHorizontalPaddingTop", {
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = +v;
            this._a("actualSeparatorHorizontalPaddingTop", this.i.bl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "separatorHorizontalPaddingBottom", {
        /**
         * Gets or sets the bottom padding for separators in the horizontal orientation.
        */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = +v;
            this._a("separatorHorizontalPaddingBottom", this.i.bu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualSeparatorHorizontalPaddingBottom", {
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
            this._a("actualSeparatorHorizontalPaddingBottom", this.i.bi);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "orientation", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = ensureEnum(ToolPanelOrientation_$type, v);
            this._a("orientation", enumToString(ToolPanelOrientation_$type, this.i.r));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "rowHeight", {
        /**
         * Gets or sets the row height for the panel.
        */
        get: function () {
            return this.i.b8;
        },
        set: function (v) {
            this.i.b8 = +v;
            this._a("rowHeight", this.i.b8);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualRowHeight", {
        /**
         * Gets the actual row height used by the panel.
        */
        get: function () {
            return this.i.bh;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "highlightWidth", {
        get: function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = +v;
            this._a("highlightWidth", this.i.bt);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualHighlightWidth", {
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
            this._a("actualHighlightWidth", this.i.bg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "highlightRadius", {
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = +v;
            this._a("highlightRadius", this.i.bs);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualHighlightRadius", {
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
            this._a("actualHighlightRadius", this.i.bf);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "highlightColor", {
        get: function () {
            return brushToString(this.i.hi);
        },
        set: function (v) {
            this.i.hi = stringToBrush(v);
            this._a("highlightColor", brushToString(this.i.hi));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualHighlightColor", {
        get: function () {
            return brushToString(this.i.gx);
        },
        set: function (v) {
            this.i.gx = stringToBrush(v);
            this._a("actualHighlightColor", brushToString(this.i.gx));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "menuArrowStroke", {
        /**
         * Gets or sets the stroke color for all icon menu dropdown arrows.
        */
        get: function () {
            return brushToString(this.i.hm);
        },
        set: function (v) {
            this.i.hm = stringToBrush(v);
            this._a("menuArrowStroke", brushToString(this.i.hm));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualMenuArrowStroke", {
        /**
         * Gets the actual stroke color for all icon menu dropdown arrows.
        */
        get: function () {
            return brushToString(this.i.g1);
        },
        set: function (v) {
            this.i.g1 = stringToBrush(v);
            this._a("actualMenuArrowStroke", brushToString(this.i.g1));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "uncheckedBackgroundColor", {
        /**
         * Gets or sets the background color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.ht);
        },
        set: function (v) {
            this.i.ht = stringToBrush(v);
            this._a("uncheckedBackgroundColor", brushToString(this.i.ht));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualUncheckedBackgroundColor", {
        /**
         * Gets the actual background color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.g8);
        },
        set: function (v) {
            this.i.g8 = stringToBrush(v);
            this._a("actualUncheckedBackgroundColor", brushToString(this.i.g8));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "checkedBackgroundColor", {
        /**
         * Gets or sets the background color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hb);
        },
        set: function (v) {
            this.i.hb = stringToBrush(v);
            this._a("checkedBackgroundColor", brushToString(this.i.hb));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualCheckedBackgroundColor", {
        /**
         * Gets the actual background color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.gq);
        },
        set: function (v) {
            this.i.gq = stringToBrush(v);
            this._a("actualCheckedBackgroundColor", brushToString(this.i.gq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "uncheckedBorderColor", {
        /**
         * Gets or sets the border color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.hu);
        },
        set: function (v) {
            this.i.hu = stringToBrush(v);
            this._a("uncheckedBorderColor", brushToString(this.i.hu));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualUncheckedBorderColor", {
        /**
         * Gets the actual border color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.g9);
        },
        set: function (v) {
            this.i.g9 = stringToBrush(v);
            this._a("actualUncheckedBorderColor", brushToString(this.i.g9));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "checkedBorderColor", {
        /**
         * Gets or sets the border color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hc);
        },
        set: function (v) {
            this.i.hc = stringToBrush(v);
            this._a("checkedBorderColor", brushToString(this.i.hc));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualCheckedBorderColor", {
        /**
         * Gets the actual border color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.gr);
        },
        set: function (v) {
            this.i.gr = stringToBrush(v);
            this._a("actualCheckedBorderColor", brushToString(this.i.gr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "dropdownDelay", {
        /**
         * Gets or sets the dropdown delay time in milliseconds.
        */
        get: function () {
            return this.i.b7;
        },
        set: function (v) {
            this.i.b7 = +v;
            this._a("dropdownDelay", this.i.b7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "actualDropdownDelay", {
        /**
         * Gets the actual dropdown delay.
        */
        get: function () {
            return this.i.b6;
        },
        set: function (v) {
            this.i.b6 = +v;
            this._a("actualDropdownDelay", this.i.b6);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "nestedActionMode", {
        /**
         * Gets or sets the mode used when displaying nested actions.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureEnum(NestedActionMode_$type, v);
            this._a("nestedActionMode", enumToString(NestedActionMode_$type, this.i.e));
        },
        enumerable: false,
        configurable: true
    });
    IgcToolPanelComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.actions != null && this.actions.findByName && this.actions.findByName(name)) {
            return this.actions.findByName(name);
        }
        return null;
    };
    Object.defineProperty(IgcToolPanelComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolPanelComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgcToolPanelComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ToolPanelComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgcToolPanelComponent.prototype.refresh = function () {
        this.i.fb();
    };
    IgcToolPanelComponent.prototype.getDesiredSize = function () {
        var iv = this.i.hv();
        return fromSize(iv);
    };
    /**
     * Forces any open sub menus to close.
    
    */
    IgcToolPanelComponent.prototype.closeSubmenus = function () {
        this.i.er();
    };
    IgcToolPanelComponent.prototype.exportVisualData = function () {
        var iv = this.i.b9();
        return (iv);
    };
    IgcToolPanelComponent.prototype.exportSerializedVisualData = function () {
        var iv = this.i.dl();
        return (iv);
    };
    Object.defineProperty(IgcToolPanelComponent.prototype, "contentRefreshed", {
        get: function () {
            return this._contentRefreshed;
        },
        set: function (ev) {
            var _this = this;
            if (this._contentRefreshed_wrapped !== null) {
                this.i.contentRefreshed = delegateRemove(this.i.contentRefreshed, this._contentRefreshed_wrapped);
                this._contentRefreshed_wrapped = null;
                this._contentRefreshed = null;
            }
            this._contentRefreshed = ev;
            this._contentRefreshed_wrapped = function (o, e) {
                var outerArgs = new IgcToolPanelContentRefreshedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeContentRefreshed) {
                    _this.beforeContentRefreshed(_this, outerArgs);
                }
                if (_this._contentRefreshed) {
                    _this._contentRefreshed(_this, outerArgs);
                }
            };
            this.i.contentRefreshed = delegateCombine(this.i.contentRefreshed, this._contentRefreshed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolPanelComponent.prototype, "onCommand", {
        get: function () {
            return this._onCommand;
        },
        set: function (ev) {
            var _this = this;
            if (this._onCommand_wrapped !== null) {
                this.i.onCommand = delegateRemove(this.i.onCommand, this._onCommand_wrapped);
                this._onCommand_wrapped = null;
                this._onCommand = null;
            }
            this._onCommand = ev;
            this._onCommand_wrapped = function (o, e) {
                var outerArgs = new IgcToolCommandEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeOnCommand) {
                    _this.beforeOnCommand(_this, outerArgs);
                }
                if (_this._onCommand) {
                    _this._onCommand(_this, outerArgs);
                }
            };
            this.i.onCommand = delegateCombine(this.i.onCommand, this._onCommand_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolPanelComponent._observedAttributesIgcToolPanelComponent = null;
    IgcToolPanelComponent.htmlTagName = "igc-tool-panel";
    IgcToolPanelComponent._isElementRegistered = false;
    return IgcToolPanelComponent;
}(IgcHTMLElement));
export { IgcToolPanelComponent };
